// Generated by CoffeeScript 1.12.3
(function() {
  var convertGarages, convertLocation, convertParkingmeters, geojsonGaragesArray, geojsonSellPointsArray, geojsonTariffArray, getGeoCoordinates, getJSON, getParkingFacilityInformation, getUuid, locations, map, parkingmeters, search, setNewLocation, tariffareas, tarriffAreaPrices, url;

  locations = void 0;

  parkingmeters = void 0;

  tariffareas = void 0;

  url = "https://amsterdam-maps.bma-collective.com/embed/parkeren/deploy_data/";

  geojsonGaragesArray = [];

  geojsonSellPointsArray = [];

  geojsonTariffArray = [];

  tarriffAreaPrices = [];

  convertGarages = function(garages) {
    var garage, geoPoint, geolocation, i, len, ref, results;
    ref = garages.parkeerlocaties;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      garage = ref[i];
      geolocation = garage.parkeerlocatie;
      geoPoint = {
        "type": "Feature",
        "geometry": JSON.parse(geolocation.Locatie),
        "properties": {
          "title": geolocation.title,
          "address": geolocation.adres,
          "postalcode": geolocation.postcode,
          "description": geolocation.opmerkingen,
          "url": geolocation.url,
          "type": geolocation.type
        }
      };
      results.push(geojsonGaragesArray.push(geoPoint));
    }
    return results;
  };

  convertParkingmeters = function(parkingmeters) {
    var geoPoint, i, len, parkingmeter, ref, results;
    ref = parkingmeters.features;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      parkingmeter = ref[i];
      geoPoint = {
        "type": parkingmeter.type,
        "geometry": parkingmeter.geometry,
        "properties": {
          "title": parkingmeter.properties.VERKOOP_PU
        }
      };
      results.push(geojsonSellPointsArray.push(geoPoint));
    }
    return results;
  };

  getParkingFacilityInformation = function(data) {
    return getJSON("./ba-simple-proxy.php?url=https://npropendata.rdw.nl/parkingdata/v2/static/" + data[0].uuid, function(data) {
      var description, parkingExtensions, tariffs;
      if (data.status.http_code === 200) {
        description = data.contents.parkingFacilityInformation.description;
        tariffs = data.contents.parkingFacilityInformation.tariffs;
        parkingExtensions = data.contents.parkingFacilityInformation.parkingExtensions;
        console.log("Total tariffs is " + tariffs.length + " in area " + description);
        if (parkingExtensions) {
          return console.log("Total parkingExtensions " + parkingExtensions.length + " of " + description);
        } else {
          return console.warn("No parkingExtensions!");
        }
      } else {
        return console.error("No data succesfully returned!");
      }
    });
  };

  getUuid = function(tariffAreas) {
    var areaKey, areaKeys, areaUuids, i, len, results, uuid;
    areaUuids = [];
    areaKeys = Object.keys(tariffAreas);
    results = [];
    for (i = 0, len = areaKeys.length; i < len; i++) {
      areaKey = areaKeys[i];
      results.push(uuid = getJSON("https://opendata.rdw.nl/resource/svfa-juwh.json?areamanagerid=363&areaid=" + areaKey, getParkingFacilityInformation));
    }
    return results;
  };

  getJSON = function(url, callback) {
    var xhr;
    xhr = new XMLHttpRequest();
    xhr.open("GET", url, true);
    xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhr.onreadystatechange = function() {
      if (this.readyState === 4) {
        if (this.status === 200) {
          return console.warn(this.responseText);
        }
      }
    };
    xhr.addEventListener("error", function() {
      return console.error("Error retrieving data");
    });
    return xhr.send();
  };

  locations = getJSON(url + "locaties.json", convertGarages);

  parkingmeters = getJSON(url + "verkooppunt.json", convertParkingmeters);

  tariffareas = getJSON(url + "tarieven.json", getUuid);

  mapboxgl.accessToken = "pk.eyJ1IjoibXlyYWRvbiIsImEiOiJjaXhwdjJ0b2YwMDI1MzJvZnF1dGlncTE5In0.QyMS4Vd8C9klIWw0Rofj4w";

  map = new mapboxgl.Map({
    container: "map",
    style: "mapbox://styles/myradon/cixpv422u005o2rph0gmeawzv",
    center: [4.895168, 52.370216],
    zoom: 12,
    pitch: 25
  });

  map.on("load", function(event) {
    this.addSource("garages", {
      type: "geojson",
      data: {
        type: "FeatureCollection",
        features: geojsonGaragesArray
      },
      cluster: true,
      clusterMaxZoom: 12,
      clusterRadius: 50
    });
    this.addSource("parkingmeters", {
      type: "geojson",
      data: {
        type: "FeatureCollection",
        features: geojsonSellPointsArray
      }
    });
    this.addSource("tariffareas", {
      type: "geojson",
      data: {
        type: "FeatureCollection",
        features: geojsonTariffArray
      }
    });
    this.addLayer({
      "id": "garages",
      "type": "symbol",
      "source": "garages",
      "layout": {
        "text-field": "{title}",
        "text-font": ["Open Sans Semibold"],
        "text-size": 20,
        "text-offset": [0, 0.5],
        "text-justify": "left",
        "text-anchor": "left"
      }
    });
    this.addLayer({
      "id": "parkingmeters",
      "type": "symbol",
      "source": "parkingmeters",
      "layout": {
        "text-field": "{title}",
        "text-font": ["Open Sans Regular"],
        "text-size": 16,
        "text-anchor": "center"
      }
    });
    return this.addLayer({
      "id": "tariffareas",
      "type": "fill",
      "source": "tariffareas",
      "paint": {
        "fill-color": "#ff0000",
        "fill-opacity": 0.3
      }
    });
  });

  search = document.querySelector('#search');

  search.addEventListener("keypress", function(event) {
    var target;
    if (event.keyCode === 13) {
      event.preventDefault();
      target = search.value;
      target = convertLocation(target);
      return getGeoCoordinates(target, setNewLocation);
    }
  });

  convertLocation = function(target) {
    var pattern;
    pattern = new RegExp(/^[1-9][0-9]{3} ?(?!sa|sd|ss)[a-z]{2}$/i);
    if (pattern.test(target)) {
      return target;
    } else {
      pattern = new RegExp(/(amsterdam)$/i);
      if (pattern.test(target)) {
        return target;
      } else {
        return target + " Amsterdam";
      }
    }
  };

  setNewLocation = function(location) {
    return map.flyTo({
      center: location.coordinates,
      zoom: 19,
      bearing: 5,
      speed: 0.75,
      curve: 2.5
    });
  };

  getGeoCoordinates = function(data, callback) {
    var result, xhr;
    data = data.replace(/\s/g, '+');
    url = "http://maps.google.com/maps/api/geocode/json?address=" + data + "&sensor=false";
    result = {
      coordinates: [],
      status: void 0
    };
    xhr = new XMLHttpRequest();
    xhr.open("GET", url);
    xhr.addEventListener("load", function() {
      var location;
      if (xhr.status === 200) {
        location = JSON.parse(xhr.responseText);
        if (location.results.length) {
          result.coordinates.push(location.results[0].geometry.location.lng, location.results[0].geometry.location.lat);
          result.status = location.status;
          return callback(result);
        } else {
          print("No results for typed location!");
          return result.states = "no results";
        }
      }
    });
    xhr.addEventListener("error", function() {
      print("error retrieving data with Maps-call");
      return result.status = "error";
    });
    return xhr.send();
  };

}).call(this);

//# sourceMappingURL=app.js.map
